EDict.prototype.mojien = {  
  _analyzeEntry : function(ent) {
    var ret = { terms: new Array(), meanings: new Array() };
    var meaningcount = 0;
    
    var parts = ent.split("/");
    
    debugger;
    
    for ( var i = 0; i < parts.length; i++ ) {
      // skip empty entries (at the beginning and the end...)
      if ( parts[i] == "" )
        continue;
      
      var test, region;
      
      while ( test = parts[i].match(/^ *\(([^\)]*)\)/) ) {
        var ta = Array();
        
        if ( region = test[1].match(/^(.+):(.*)/) ) {
          // regional tag
          var f = "";
          
          switch ( region[1] ) {          
            case "kyb": f = "Kyoto-ben"; break;
            case "osb": f = "Osaka-ben"; break;
            case "ksb": f = "Kansai-ben"; break;
            case "ktb": f = "Kantou-ben"; break;
            case "tsb": f = "Tosa-ben"; break;
            case "ar": f = "Arabic"; break;
            case "zh": f = "Chinese (Zhongwen)"; break;
            case "de": f = "German (Deutsch)"; break;
            case "en": f = "English"; break;
            case "fr": f = "French"; break;
            case "el": f = "Greek (Ellinika)"; break;
            case "iw": f = "Hebrew (Iwrith)"; break;
            case "ja": f = "Japanese"; break;
            case "ko": f = "Korean"; break;
            case "nl": f = "Dutch (Nederlands)"; break;
            case "no": f = "Norwegian"; break;
            case "pl": f = "Polish"; break;
            case "ru": f = "Russian"; break;
            case "sv": f = "Swedish"; break;
            case "bo": f = "Tibetan (Bodskad)"; break;
            case "eo": f = "Esperanto"; break;
            case "es": f = "Spanish"; break;
            case "in": f = "Indonesian"; break;
            case "it": f = "Italian"; break;
            case "lt": f = "Latin"; break;
            case "pt": f = "Portugese"; break;
            case "hi": f = "Hindi"; break;
            case "ur": f = "Urdu"; break;
            case "mn": f = "Mongolian"; break;
            case "kl": f = "Inuit (formerly Eskimo)"; break;
            case "ai": f = "Ainu"; break;
          }

          // if we do not know this tag, stop the parsing. The first unknown tag is considered
          // to be a normal part of the translation put in "()".
          if ( f == "" )
            break;
                       
          f = f + ":" + region[2];
          ta.push({abbrev: test[1], full: f});
        } else if ( mno = test[1].match(/^[0-9]+$/) ) {
          meaningcount = test[1];
          
          if ( ! ret.meanings[meaningcount] ) {
            ret.meanings[meaningcount] = { terms: new Array(), translations: new Array() };
          }
        } else {
          // lexical tag
          var tags = test[1].split(",");
          var exitwhile = false;
          
          for ( var j = 0; j < tags.length; j++ ) {
            var f = "";
            
            switch ( tags[j] ) {
              case "abbr": f = "abbreviation"; break;
              case "adj": f = "adjective (keiyoushi)"; break;
              case "adv": f = "adverb (fukushi)"; break;
              case "adj-na": f = "adjectival nouns or quasi-adjectives (keiyodoshi)"; break;
              case "adj-no": f = "nouns which may take the genitive case particle \"no\""; break;
              case "adj-pn": f = "pre-noun adjectival (rentaishi)"; break;
              case "adj-s": f = "special adjective (e.g. ookii)"; break;
              case "adj-t": f = "\"taru\" adjective"; break;
              case "arch": f = "archaism"; break;
              case "aux": f = "auxiliary word or phrase"; break;
              case "aux-v": f = "auxiliary verb"; break;
              case "conj": f = "conjunction"; break;
              case "col": f = "colloquialism"; break;
              case "exp": f = "Expressions (phrases, clauses, etc.)"; break;
              case "ek": f = "exclusively kanji, rarely just in kana"; break;
              case "fam": f = "familiar language"; break;
              case "fem": f = "female term or language"; break;
              case "gikun": f = "gikun (meaning) reading"; break;
              case "gram": f = "grammatical term"; break;
              case "hon": f = "honorific or respectful (sonkeigo) language"; break;
              case "hum": f = "humble (kenjougo) language"; break;
              case "id": f = "idiomatic expression"; break;
              case "int": f = "interjection (kandoushi)"; break;
              case "iK": f = "word containing irregular kanji usage"; break;
              case "ik": f = "word containing irregular kana usage"; break;
              case "io": f = "irregular okurigana usage"; break;
              case "MA": f = "martial arts term"; break;
              case "male": f = "male term or language"; break;
              case "m-sl": f = "manga slang"; break;
              case "n": f = "noun (common) (futsuumeishi)"; break;
              case "n-adv": f = "adverbial noun (fukushitekimeishi)"; break;
              case "n-t": f = "noun (temporal) (jisoumeishi)"; break;
              case "n-suf": f = "noun, used as a suffix"; break;
              case "neg": f = "negative (in a negative sentence, or with negative verb)"; break;
              case "neg-v": f = "negative verb (when used with)"; break;
              case "obs": f = "obsolete term"; break;
              case "obsc": f = "obscure term"; break;
              case "oK": f = "word containing out-dated kanji"; break;
              case "ok": f = "out-dated or obsolete kana usage"; break;
              case "pol": f = "polite (teineigo) language"; break;
              case "pref": f = "prefix"; break;
              case "qv": f = "quod vide (see another entry)"; break;
              case "sl": f = "slang"; break;
              case "suf": f = "suffix"; break;
              case "uK": f = "word usually written using kanji alone"; break;
              case "uk": f = "word usually written using kana alone"; break;
              case "v1": f = "Ichidan verb"; break;
              case "v5": f = "Godan verb (not completely classified)"; break;
              case "v5u": f = "Godan verb with `u' ending"; break;
              case "v5k": f = "Godan verb with `ku' ending"; break;
              case "v5g": f = "Godan verb with `gu' ending"; break;
              case "v5s": f = "Godan verb with `su' ending"; break;
              case "v5t": f = "Godan verb with `tsu' ending"; break;
              case "v5n": f = "Godan verb with `nu' ending"; break;
              case "v5b": f = "Godan verb with `bu' ending"; break;
              case "v5m": f = "Godan verb with `mu' ending"; break;
              case "v5r": f = "Godan verb with `ru' ending"; break;
              case "v5k-s": f = "Godan verb - Iku/Yuku special class"; break;
              case "v5z": f = "Godan verb - -zuru special class (alternative form of -jiru verbs)"; break;
              case "v5aru": f = "Godan verb - -aru special class"; break;
              case "v5uru": f = "Godan verb - Uru old class verb (old form of Eru)"; break;
              case "vi": f = "intransitive verb"; break;
              case "vs": f = "noun or participle which takes the aux. verb suru"; break;
              case "vs-s": f = "suru verb - special class"; break;
              case "vk": f = "Kuru verb - special class"; break;
              case "vt": f = "transitive verb"; break;
              case "vulg": f = "vulgar expression or word"; break;
              case "X": f = "rude or X-rated term (not displayed in educational software)"; break;
              
              case "P": f = "Priority Entry"; break;
            }
            
            if ( f == "" ) {
              exitwhile = true;
              break;
            }
            
            ta.push({abbrev: test[1], full: f});
          }
          
          if ( exitwhile )
            break;
        }

        if ( ta.length > 0 ) {          
          if ( meaningcount == 0 )
            ret.terms.push(ta);
          else
            ret.meanings[meaningcount].terms.push(ta);
        }
        
        // now remove the first tag from the part
        parts[i] = parts[i].replace(/^ *\([^\)]*\) */, "");
      }
      
      if ( meaningcount == 0 ) {
        if ( ! ret.meanings[1] ) {
          ret.meanings[1] = { terms: new Array(), translations: new Array() };
        }
        meaningcount = 1;
      }
      
      ret.meanings[meaningcount].translations.push(parts[i]);
    }
    
    return ret;
  }
}